diff -ru PyWebDAV-0.9~/DAV/iface.py PyWebDAV-0.9/DAV/iface.py
--- PyWebDAV-0.9~/DAV/iface.py	2009-05-01 17:36:40.000000000 +0200
+++ PyWebDAV-0.9/DAV/iface.py	2009-05-02 19:07:35.000000000 +0200
@@ -93,7 +93,7 @@
     def put(self,uri,data):
         """ write an object to the repository 
 
-        return a result code or raise an exception
+        return the location uri or raise an exception
         """
 
         raise DAV_Forbidden
diff -ru PyWebDAV-0.9~/DAV/WebDAVServer.py PyWebDAV-0.9/DAV/WebDAVServer.py
--- PyWebDAV-0.9~/DAV/WebDAVServer.py	2009-05-01 20:33:41.000000000 +0200
+++ PyWebDAV-0.9/DAV/WebDAVServer.py	2009-05-02 19:08:39.000000000 +0200
@@ -331,11 +331,14 @@
         if self.headers.has_key("Content-Type"):
             ct=self.headers['Content-Type']
         try:
-            dc.put(uri,body,ct)
+            location = dc.put(uri,body,ct)
         except DAV_Error, (ec,dd):
             self.send_status(ec)
             return
-        self.send_status(201)
+        headers = {}
+        if location:
+            headers['Location'] = location
+        self.send_status(201, headers=headers)
 
     def do_COPY(self):
         """ copy one resource to another """
